#include "slick.sh"
#import "stdprocs.e"
#import "SymHighlightJOE.e"

#define COLOR_DEF_BG 0x80000008         // Default background for that control
#define COLOR_DEF_FG 0x80000005         // Default foreground for that control
#define COLOR_DEF_DLG_BG 0x80000022     // Default dialog background color

static void dbgsay(_str msg)
{
//    _SccDisplayOutput("DLG: " msg);
//    say("DLG: " msg);
}


/// Begin Dialog Support
#define DLGINFO_CURRENT_HIGHLIGHT_WID 0
#define DLGINFO_CURRENT_BUFFER 1
class DialogBufferFocus //: sc.lang.IAssignTo 
{
    private int m_MainForm = 0;
    private int m_TreeCtrl = 0;
    private _str m_formName;

    public void log() {
        dbgsay("DialogBufferFocus log, id:" m_MainForm );
    }

    private void _setCurrentHighlightWid(int highlight_wid)
    {
        if (m_MainForm != 0)
        {
            dbgsay("Set DLGINFO_CURRENT_HIGHLIGHT_WID: " highlight_wid);
            _SetDialogInfo(DLGINFO_CURRENT_HIGHLIGHT_WID, highlight_wid, m_MainForm);
        }
    }

    private void _setCurrentHighlightBuffer(_str highlight_bufname)
    {
        if (m_MainForm != 0)
        {
            _SetDialogInfo(DLGINFO_CURRENT_BUFFER, highlight_bufname, m_MainForm);
        }
    }

    private int _tbGetActiveHighlightForm()
    {
        if (!_iswindow_valid(m_MainForm))
        {
            m_MainForm = 0;
            m_TreeCtrl = 0;
        }
        return m_MainForm;//w_find_form('form1');
    }

    private int _validate_highlight_buffer(int highlight_wid)
    {
        if (highlight_wid <= 0 || !_iswindow_valid(highlight_wid))
        {
            highlight_wid = _mdi._edit_window();
        }
        if (highlight_wid)
        {
            if (!highlight_wid.p_HasBuffer || (highlight_wid.p_window_flags & HIDE_WINDOW_OVERLAP))
            {
                highlight_wid = 0;
            }
        }
        return(highlight_wid);
    }

    private int _getCurrentHighlightWid()
    {
        if (m_MainForm != 0)
        {
            int wid = _GetDialogInfo(DLGINFO_CURRENT_HIGHLIGHT_WID, m_MainForm);
            dbgsay("Get DLGINFO_CURRENT_HIGHLIGHT_WID1: " m_MainForm);
            dbgsay("Get DLGINFO_CURRENT_HIGHLIGHT_WID2: " (_str)wid);
            return wid;
        }
        return 0;
    }

    private _str _getCurrentHighlightBuffer()
    {
        if (m_MainForm != 0)
        {
            return _GetDialogInfo(DLGINFO_CURRENT_BUFFER, m_MainForm);
        }
        return "";
    }

    private void _init_current_highlight_buffer(int highlight_wid)
    {
//    if (ignore_switchbuf)
//    {
//        return;
//    }
//    return;
        dbgsay("_init_current_highlight_buffer");
        _str highlight_bufname = "";
        int orig_wid;
        get_window_id(orig_wid);
        int form_id = _tbGetActiveHighlightForm();
        if (form_id == 0)
        {
            dbgsay("NOFORM!2:");
            return;
        }
        activate_window(form_id);
        highlight_wid = _validate_highlight_buffer(highlight_wid);
        if (highlight_wid)
        {
            highlight_bufname = highlight_wid.p_buf_name;
            dbgsay("BUFNAME:"highlight_bufname);
        }
        if (highlight_wid == _getCurrentHighlightWid())
        {
            if (highlight_wid)
            {
                if (highlight_bufname == _getCurrentHighlightBuffer())
                {
                    activate_window(orig_wid);
                    return;
                }
            }
        }
        _setCurrentHighlightWid(highlight_wid);
        _setCurrentHighlightBuffer(highlight_bufname);
        if (highlight_wid == 0)
        {
        }
        else
        {
            //if ((bufname :== '') || _isGrepBuffer(bufname) || (bufname == '.process') || _isDSBuffer(bufname) || (highlight_wid.p_buf_flags & VSBUFFLAG_HIDDEN)) {
            //   _findbookmark_all.p_enabled = false;
            //} else {
            //   _findbookmark_all.p_enabled = true;
            //}
        }
        //PUSER_FINDFILES_INIT_DONE = '';
        activate_window(orig_wid);
    }

    private int _get_current_highlight_wid()
    {
        if ( p_active_form && p_active_form.p_name == m_formName )
        {
            int wid =  _getCurrentHighlightWid();
            if ( wid > 0 && _iswindow_valid(wid) )
            {
                return wid;
            }
        }
        dbgsay("NOHIGH");
        return 0;
    }

    void setActiveHighlightWindow()
    {
        int formid = _tbGetActiveHighlightForm();
        if (formid == 0 )
        {
            dbgsay("NOFORM");
            return;
        }
        int window_id = 0;
        if (_mdi.p_child._no_child_windows() == 0)
        {
            if (p_HasBuffer)
            {
                if (p_mdi_child)
                {
                    window_id = _mdi.p_child.p_window_id;
                }
                else
                {
                    window_id = p_window_id;
                }
            }
            else
            {
                window_id = _mdi.p_child.p_window_id;
            }
        }
        _init_current_highlight_buffer(window_id);
    }

    int activateHighlightWindow()
    {
        int window_id = _get_current_highlight_wid();
        if (window_id == 0)
        {
            dbgsay("NO ACTIVE HIGHLIGHT");
            return(0);
        }
        dbgsay("ActiveHigh: " window_id);
        activate_window(window_id);
        _ExitScroll();
        return(window_id);
    }

    void dumpListOfWindows()
    {
        #if 0
        dbgsay("ACT: " p_active_form.p_name);
        int StartWindowID = p_window_id;

        int lastwindow_id;
        int done = 0;
        int index = 0;

        _prev_window('HF');
        lastwindow_id=p_window_id;
        _next_window('HF');
        for (;;)
        {
            dbgsay("WIN: " p_window_id.p_name);
            if ( p_window_id== lastwindow_id )
            {
                done=1;
            }
            _next_window('HR');
            if ( done )
            {
                break;
            }
        }
        p_window_id = StartWindowID;
        #endif
    }

    public DialogBufferFocus(_str formName = "", int wid = 0, int tree = 0) {
        m_formName = formName;
        m_MainForm = wid;
        m_TreeCtrl = tree;

        if (wid != 0)
        {
            dbgsay("DialogBufferFocus construct, id:" m_MainForm);
            //_SetDialogInfoHt("MyThis", this, m_TreeCtrl, true);
        }
        _setCurrentHighlightWid(0);
        _setCurrentHighlightBuffer("");
    }

    public ~DialogBufferFocus() {
        dbgsay("~DialogBufferFocus destruct, id:" m_MainForm);
    }
};
/// End Dialog Support

enum FinderColumns
{
    FC_ENABLED,
    FC_WHOLEWORD,
    FC_COLOR,
    FC_NEEDLE
};

//#define CHECK_SWITCH
//#define CHECK_BOXEN true
#define CHECK_TEXTONLY
#define CHECK_STRING_ENABLED "[+]"
#define CHECK_STRING_DISABLED "[ ]"

typedef typeless (*onEventFn)(int reason, int index, _str &value, int wid);
static onEventFn gEventTable:[];
static typeless form1_p = 0;
static typeless list_ctrl = 0;
static boolean switchOK = true;

static DialogBufferFocus *get_tree_object()
{
    if (form1_p != 0)
    {
        if (_iswindow_valid(form1_p))
        {
            //dbgsay("form!" form1_p);
            DialogBufferFocus *p = _GetDialogInfoHtPtr("MyThis", form1_p, true);
            if (!p)
            {
                dbgsay("No object pointer3!");
                return null;
            }
            return p;
        }
        else
        {
            dbgsay("No form 2!");
            form1_p = 0;
            list_ctrl = 0;
        }
    }
    dbgsay("No form!" form1_p);
    return null;
}

void _switchbuf_tbhighlight(_str oldbuffname, _str flag)
{
    if (switchOK)
    {
        switchOK = false;
        DialogBufferFocus *p = get_tree_object();
        if (!p)
        {
            return;
        }
        p->setActiveHighlightWindow();
        switchOK = true;
    }
}

static int findItem(int list_ctrl, WordInfo &sym)
{
    int found = -1;
    int index = list_ctrl._TreeGetNextIndex(0);
    while (index != -1)
    {
        _str text =  list_ctrl._TreeGetCaption(index, FC_NEEDLE);
        if (text == sym.m_Word)
        {
            found = index;
            break;
        }
        index = list_ctrl._TreeGetNextIndex(index);
    }
    return found;
}

//static int dumpTable(int list_ctrl)
//{
//    int found = -1;
//    int index = list_ctrl._TreeGetNextIndex(0);
//    dbgsay("---------------   dumpTable   ------------");
//    while (index != -1)
//    {
//        WordInfo itemSym = list_ctrl._TreeGetUserInfo(index);
//        SymColour symColor = GetSymColor(itemSym.m_Color);
//        _str colorName = "<none>";
//        if (symColor != null)
//        {
//            colorName = symColor.m_name;
//        }
//        //items = items " " text;
//        dbgsay("    Item: (" index ") is '" itemSym.m_Word "', Color: " itemSym.m_Color ", " colorName);
//        index = list_ctrl._TreeGetNextIndex(index);
//    }
//    //dbgsay("ITEMS: " items);
//
//    return found;
//}

static boolean getCheckState(int ctrlid, int index, int col)
{
    #ifdef CHECK_BOXEN
    return ctrlid._TreeGetCheckState(index, col) !=0;
    #endif

    #ifdef CHECK_TEXTONLY
    _str text =  ctrlid._TreeGetCaption(index, col);
    dbgsay("CHECK_TEXTONLY("index") text:" text ", testis+:" (text == CHECK_STRING_ENABLED));
    return text == CHECK_STRING_ENABLED;
    #endif

    #ifdef CHECK_SWITCH
    return (ctrlid._TreeGetSwitchState(index, col)) ? true : false;
    #endif
}

static void setCheckState(int ctrlid, int index, int col, boolean state)
{
    #ifdef CHECK_BOXEN
    ctrlid._TreeSetCheckState(index, (int)state, col);
    #endif

    #ifdef CHECK_TEXTONLY
    dbgsay("TREESETCAPTION: ("index") " (state ? CHECK_STRING_ENABLED : CHECK_STRING_DISABLED) ", col: " col);
    ctrlid._TreeSetCaption(index, state ? CHECK_STRING_ENABLED : CHECK_STRING_DISABLED, col);
    #endif

    #ifdef CHECK_SWITCH
    ctrlid._TreeSetSwitchState(index, col, state);
    #endif
}

void _highlight_changecolor_tb(WordInfo &sym) // called by SymHighlight
{
    dbgsay("_highlight_changecolor_tb: " sym);
    _highlight_addword_tb(sym);
}

void _highlight_addword_tb(WordInfo &sym) // called by SymHighlight
{
    dbgsay("_highlight_addword_tb: " sym);
    DialogBufferFocus *p = get_tree_object();
    if (p)
    {
        //int index = list_ctrl._TreeSearch(0,  sym, "IST", 0, FC_NEEDLE);
        int index = findItem(list_ctrl, sym);
        dbgsay("_highlight_addword_tbXX: " sym);
        if (index == -1)
        {
            dbgsay("Item not found: " sym);
            index = addItem(list_ctrl, sym, true);
        }
        else
        {
            WordInfo itemSym = list_ctrl._TreeGetUserInfo(index);
            if (itemSym != sym)
            {
                setItemState(list_ctrl, index, sym);
                //list_ctrl._TreeDelete(index);
                //index = addItem(list_ctrl, sym, false);
            }
            else
            {
                setItemState(list_ctrl, index, sym);
                dbgsay("ADDWORD AVOIDED");
            }
        }
    }
}

void _highlight_delword_tb(WordInfo &sym) // called by SymHighlight
{
    //_post_call( def_highlight_delword_tb, sym);
    dbgsay("_highlight_delword_tb");
    DialogBufferFocus *p = get_tree_object();
    if (p)
    {
        //int index = list_ctrl._TreeSearch(0,  sym, "IST", 0, FC_NEEDLE);
        int index = findItem(list_ctrl, sym);
        if (index != -1)
        {
            sym.m_Enabled = false;
            setCheckState(list_ctrl, index, FC_ENABLED, sym.m_Enabled);
            list_ctrl._TreeSetUserInfo(index, sym);
        }
    }
}

static void addEventHandler(int reason, FinderColumns col, onEventFn fn)
{
    _str id = "" reason "," col;
    gEventTable:[id] = fn;
    dbgsay("addEventHandler EVENTID: " id);
}

static int changeWord(DialogBufferFocus *p, _str fromWord, WordInfo &toWord)
{
    dbgsay("changeWord from '" fromWord "', to '" toWord "'");
    int orig_wid;
    get_window_id(orig_wid);
    int windowid = p->activateHighlightWindow();
    if (0 == windowid)
    {
        dbgsay("FNF");
        return(FILE_NOT_FOUND_RC);
    }

    //dbgsay("onNeedle window: " windowid);
    if (fromWord != "")
    {
        WordInfo removed;
        if (RemoveHighlightWord(fromWord, removed))
        {
            dbgsay("TOCOLOR set to " removed.m_Color);
            toWord.m_Color = removed.m_Color;
        }
    }
    AddHighlightWord(toWord);
    activate_window(orig_wid);
    return 0;
}

static typeless onToggleEnabled(int reason, int index, _str &value="",int wid=0)
{
    DialogBufferFocus *p = get_tree_object();
    if (!p)
    {
        return 0;
    }

    boolean enabled = getCheckState(list_ctrl, index, FC_ENABLED);
    #ifdef CHECK_TEXTONLY
    enabled = !enabled;
    setCheckState(list_ctrl, index, FC_ENABLED, enabled);
    #endif

    _str text =  list_ctrl._TreeGetCaption(index, FC_NEEDLE);
    WordInfo wordSym = list_ctrl._TreeGetUserInfo(index);
    dbgsay("Enabled ("index") is :" enabled " caption:" text ", WORD:" wordSym.toStringDbg());
    int result = 0;
    wordSym.m_Enabled = enabled;
    if (!enabled)
    {
        WordInfo wordSymEmpty;
        result = changeWord(p, text, wordSymEmpty);
        wordSym.m_Color = wordSymEmpty.m_Color;
    }
    else
    {
        result = changeWord(p, "", wordSym);
    }
    list_ctrl._TreeSetUserInfo(index, wordSym);
    return result;
}

static typeless onToggleWord(int reason, int index, _str &value="",int wid=0)
{
    DialogBufferFocus *p = get_tree_object();
    if (!p)
    {
        return 0;
    }

    boolean enabled = getCheckState(list_ctrl, index, FC_WHOLEWORD);
    #ifdef CHECK_TEXTONLY
    enabled = !enabled;
    setCheckState(list_ctrl, index, FC_WHOLEWORD, enabled);
    #endif

    _str text =  list_ctrl._TreeGetCaption(index, FC_NEEDLE);
    WordInfo wordSym = list_ctrl._TreeGetUserInfo(index);
    wordSym.m_WordMatch = enabled;
    list_ctrl._TreeSetUserInfo(index, wordSym);
    dbgsay("WordMatch is :" enabled " caption:" text ", WORD:" wordSym.toStringDbg());

    int result = changeWord(p, wordSym.m_Word, wordSym);
    list_ctrl._TreeSetUserInfo(index, wordSym);
    return result;
}

static typeless onNeedle(int reason, int index, _str &value="",int wid=0)
{
    dbgsay("TEXT: " value ", Highlights: " form1_p);
    if (!form1_p)
    {
        return 0;
    }
    DialogBufferFocus *p = _GetDialogInfoHtPtr("MyThis", form1_p, true);
    if (!p)
    {
        dbgsay("No object pointer!");
        return 0;
    }
    //p->dumpListOfWindows();

    //_str words[] = GetHighlightWords();
    WordInfo wordSym = list_ctrl._TreeGetUserInfo(index);
    _str oldWord = wordSym.m_Word;
    wordSym.m_Word = value;
    int result = changeWord(p, oldWord, wordSym);
    list_ctrl._TreeSetUserInfo(index, wordSym);
    return result;
}

static int addItem(int treectrl, WordInfo &sym, boolean append = true)
{
    int index = treectrl._TreeGetNextIndex(TREE_ROOT_INDEX);

    _str word = sym.m_WordMatch ? CHECK_STRING_ENABLED : CHECK_STRING_DISABLED;
    _str item = "+\t" word "\t" sym.m_Word;

    dbgsay("Add item: " item);
    if (index == -1 || append)
    {
        index = treectrl._TreeAddItem(TREE_ROOT_INDEX, item, TREE_ADD_AS_CHILD, 0, 0, TREE_NODE_LEAF);
    }
    else
    {
        index = treectrl._TreeAddItem(index, item, TREE_ADD_BEFORE, 0, 0, TREE_NODE_LEAF);
    }
    treectrl._TreeSetNodeEditStyle(index, FC_NEEDLE, TREE_EDIT_TEXTBOX);
//    treectrl._TreeSetNodeEditStyle(index, FC_COLOR, TREE_EDIT_EDITABLE_COMBOBOX);
    setItemState(treectrl, index, sym);
    return index;
}

static void setItemState(int treectrl, int index, WordInfo &sym)
{
    treectrl._TreeSetCaption(index, sym.m_Word, FC_NEEDLE);
    setCheckState(treectrl, index, FC_WHOLEWORD, sym.m_WordMatch);
    setCheckState(treectrl, index, FC_ENABLED, sym.m_Enabled);
    treectrl._TreeSetUserInfo(index, sym);

    int fg = 0;
    int bg = 0;
    treectrl._TreeGetColor(index, 0, fg, bg, 0);
    treectrl._TreeSetColor(index, FC_COLOR, fg, bg, 0 );
    if (sym.m_Color >= 0)
    {
        SymColour symColor = GetSymColor(sym.m_Color);
        int color = symColor.m_rgb;//ColourSymHighlight;
        if (color >= 0)
        {
            treectrl._TreeSetColor(index, FC_COLOR, fg, color, F_INHERIT_FG_COLOR);
            treectrl._TreeSetCaption(index, symColor.m_name, FC_COLOR);
        }
    }
}

defeventtab Highlights;
void ctl_new_button.lbutton_up()
{
    // TODO: Add new item
}

void Highlights.on_resize()
{
    int xbuff=ctl_tree.p_x;
    int ybuff=ctl_tree.p_y;
    int form_width=_dx2lx(SM_TWIP,p_client_width);
    int form_height=_dy2ly(SM_TWIP,p_client_height);
    ctl_tree.p_width=form_width-(xbuff+xbuff+ctl_new_button.p_width+xbuff);
    ctl_tree.p_height=form_height-ybuff*2;

    ctl_new_button.p_x=ctl_tree.p_x+ctl_tree.p_width+xbuff;
    ctl_del_button.p_x=ctl_tree.p_x+ctl_tree.p_width+xbuff;
}

void ctl_del_button.lbutton_up()
{
    int index = ctl_tree._TreeCurIndex();
    if (index > 0)
    {
        DialogBufferFocus *p = get_tree_object();
        if (!p)
        {
            return;
        }

        boolean enabled = (list_ctrl._TreeGetSwitchState(index, FC_ENABLED)) ? true : false;
        _str text =  list_ctrl._TreeGetCaption(index, FC_NEEDLE);
        dbgsay("Delete, Enabled: " enabled ", TEXT:" text);
        if (enabled)
        {
            WordInfo wordSym;
            changeWord(p, text, wordSym);
        }
        ctl_tree._TreeDelete(index);
    }
}

void  Highlights.'e'()
{
    int info = 0;
    int index = _TreeGetNextSelectedIndex(1, info);
    if (index != -1)
    {
        onToggleEnabled(CHANGE_EDIT_PROPERTY, index) ;
    }
}

void  Highlights.'w'()
{
    int info = 0;
    int index = _TreeGetNextSelectedIndex(1, info);
    if (index != -1)
    {
        onToggleWord(CHANGE_EDIT_PROPERTY, index);
    }
}

typeless ctl_tree.on_change(int reason, int index,int col=-1,_str &value="",int wid=0)
{
    if (list_ctrl == 0)
    {
        dbgsay("NO LIST!");
        setupState(p_active_form, p_window_id);
    }

    #ifdef CHECK_BOXEN
    if (reason == CHANGE_CHECK_TOGGLED || reason == CHANGE_SELECTED || reason == CHANGE_EDIT_PROPERTY)
    {
        WordInfo wordSym = list_ctrl._TreeGetUserInfo(index);
        boolean enabled = getCheckState(list_ctrl, index, FC_ENABLED);
        boolean ww = getCheckState(list_ctrl, index, FC_WHOLEWORD);
        typeless result = null;
        if (enabled != wordSym.m_Enabled)
        {
            result = onToggleEnabled(reason, index, value, wid);
        }
        if (ww != wordSym.m_WordMatch)
        {
            result = onToggleWord(reason, index, value, wid);
        }
        //DbgDumpSymHighlight();
        //dumpTable(list_ctrl);
        return result;
    }
    #endif

    //_str reasonName = gChangeId:[reason];
    //if (reasonName == null)
    //{
    //    reasonName = "(" reason ")";
    //}
    _str id = "" reason "," (FinderColumns)col;
    _str reasonName = "(" reason ")";

    dbgsay("EVENTID: ("index") " reasonName "," (FinderColumns)col ", col = " col);// ", Enabled=" enabled ", WW=" ww);
    onEventFn fn = gEventTable:[id];
    if (fn != null)
    {
        typeless result = (*fn)(reason,  index,  value, wid);
        //DbgDumpSymHighlight();
        //dumpTable(list_ctrl);
        return result;
    }

    return 0;
}

void ctl_tree.on_create()
{
    //execute('slickc-debug-start');
    dbgsay("ctl_tree.on_create()");

    // TREE_BUTTON_SORT
    _TreeSetColButtonInfo(FC_ENABLED, 550, 0, -1, "Enabled" );
    _TreeSetColButtonInfo(FC_WHOLEWORD, 550, 0, -1, "Word" );
    _TreeSetColButtonInfo(FC_COLOR, 350, 0, -1, "Color" );
    _TreeSetColButtonInfo(FC_NEEDLE, 350, 0, -1, "Text" );

    auto prev = null;
    //auto container1 = prev = _TreeAddItem(0,"Container1\tColum\tData",TREE_ADD_AS_CHILD, _pic_fldclos, _pic_fldaop,0);

    WordInfo words[] = GetHighlightWords();
    int i;

    p_EditInPlace = true;
    setupState(p_active_form, p_window_id);

    for (i = 0; i < words._length(); ++i)
    {
        addItem(list_ctrl, words[i]);
    }

    _TreeAdjustColumnWidthsByColumnCaptions();
    _TreeExpandAll();

    DialogBufferFocus *p = _GetDialogInfoHtPtr("MyThis", form1_p, true);
    if (!p)
    {
        dbgsay("No object pointer3!");
        return;
    }
    p->setActiveHighlightWindow();

    p_NeverColorCurrent = false;

    parse _default_color(CFG_WINDOW_TEXT) with auto fg auto bg auto fontFlags;
    dbgsay("CFG_WINDOW_TEXT: fg:"dec2hex(fg)", bg:"dec2hex(bg)"");

    dbgsay("CREATED");
}

void setupState(int activeForm, int listCtrl)
{
    form1_p = activeForm;
    list_ctrl = listCtrl;
    dbgsay("Form is: " form1_p);
    DialogBufferFocus c1("Highlights", form1_p, listCtrl);
    _SetDialogInfoHt("MyThis", c1, form1_p, true);
    addEventHandler(CHANGE_EDIT_CLOSE, FC_NEEDLE, onNeedle);
    #ifndef CHECK_BOXEN
    addEventHandler(CHANGE_SWITCH_TOGGLED, FC_ENABLED, onToggleEnabled);
    addEventHandler(CHANGE_SWITCH_TOGGLED, FC_WHOLEWORD, onToggleWord);
    addEventHandler(CHANGE_EDIT_PROPERTY, FC_ENABLED, onToggleEnabled);
    addEventHandler(CHANGE_EDIT_PROPERTY, FC_WHOLEWORD, onToggleWord);
    #endif
}

defload()
{
    dbgsay("DIALOG DEFLOAD: " );
}
definit()
{
    dbgsay("DIALOG DEFINIT: " );
}

_exit_cleanup()
{
    dbgsay("DIALOG EXIT: " );
}

